#define PNC_H

/* PNC parameter block for atomic_clear_then_add operations */ 

typedef struct {         
	short *cta_addr;     /* virtual address to alter */
	short cta_mask;      /* mask of bits to clear before adding */
	short cta_incr;      /* increment to add in */
	short cta_oldvalue;  /* return value: old contents of altered word */
} PNC_cta_param_block;

/* write to addmem triggers an atomic_cta  using the provided param block */
#define perform_cta (*(PNC_cta_param_block **) 0xffffd100)

