struct SV_struct {
	int 		num_procs;
	short 		barrier_flag;
	short 		barrier_count;
	EH			main_event;

	slock      s;
	tlock      t;
	alock      a;
	mlock      m;

	long        time[256];
	OID         shared_segoid[256];
	long 		scratch;
	short       continue_flag;
};

struct SV2_struct {
	union { 
		mlink m_link;
		alink a_link; 
	} distributed_locks;
	short	my_flag;
	short	*right;
	short	*left;
};

extern struct SV_struct *SV;
extern struct SV2_struct *shared[256];
