
	.globl _simple_lock
	.align 2
_simple_lock:
		movl	4(%esp),%ecx	# addr of lock
top:
		movb	$1,%al
		xchgb	%al,(%ecx)		# test and set 

		cmpb	$0,%al
		je	done				# if equal, we got the lock 
spin:
		cmpb	$0,(%ecx)		# spin in cache until unlocked 
		je	top					# unlocked --> try t&s again
		jmp	spin 				
done:
		ret

	.globl _simple_unlock
	.align 2
_simple_unlock:
		movl	4(%esp),%eax	# addr of lock
		movb	$0,(%eax)		# release lock 
		ret
