#include <xmem.h>
#include <bbn_atomic.h>
#include "mcs.h"

mcs_lock(l,e)
MCSlock *l;
qnode *e;
{
	qnode *predecessor;
	e->next = nil;
	predecessor = (qnode *) xmemul(l,e);
	if (predecessor != nil) {
		e->locked =  True;
		predecessor->next = e;
		while (e->locked != False);
	}
}

mcs_unlock(l,e)
MCSlock *l;
qnode *e;
{
	if (e->next == l) { 
		if (((qnode *) atomcas32(l,e,nil)) == e) return;
		while (e->next == nil);
	} 
	e->next->locked = False;
}
